--* Begin List of Functions & Procedures *
---> File: C:\EUPHORIA\INCLUDE\QFS.E
--function floppies()
--function hard_drives()
--function ListSelect(sequence RC,sequence s,integer many)
--function EffectivePath(sequence p,sequence choice)
--function QDir(sequence path)
--global function fs()
--* End List of Functions & Procedures   *
--**************************************
--qfs.e in Euphoria
--A PC DOS-based include file
--By Quark (DB James) - 08/15/99
--Purpose: Develop basic file select routine
--**************************************
include get.e      --s=get(fn)
include graphics.e --all_palette(s)
include machine.e  --allocate(i)
include file.e     --allow_break
include sort.e     --custom_sort(i,s1)
include qtext.e    --Quark-written or collected text routines
--======================================
--with trace
--trace(1)
--======================================
--Declarations - Other terms: global, static
integer oldTColor,oldBColor
sequence curHue,rc
sequence temp
--======================================
--Definitions
--oldTColor=vc[VC_COLOR]
oldTColor=BRIGHT_WHITE
oldBColor=BLUE
curHue={BLACK,GREEN,BRIGHT_GREEN,WHITE} --text,back,highlight,select
temp={}
for i='A' to 'Z' do
   temp=append(temp,repeat(i,5))
end for
--======================================
--Procedures & Functions
----------------------------------------
function floppies()

--  Peek() at the BIOS Equipment Word to return a list of floppy
--  drives installed on the system.
--
-- CREDIT(S)
--  Larry Stone, based on a routine published in MicroHelp's BUG
--  Newsletter, 1/1/90.

    integer fCount
    sequence list

    -- get count of floppies
    fCount = floor( peek( #410 ) / 64 + 1 )

    -- clear the list
    list = {}

    -- each floppy gets a letter
    for drive = 1 to fCount do
        -- append a floppy drive
        list = append( list, "<-" & { 'A' + drive - 1 } & "->" )
    end for

    return list

end function
----------------------------------------
function hard_drives()

--    Uses DOS ISR 21H, Function 44H, Subfunction 09H (Is Drive Remote)
--    to return a list of valid, local hard drives.

-- CREDIT(S)
--    Larry Stone, based on a routine published in MicroHelp's BUG
--    Newsletter, 1/1/90.

    sequence inReg, outReg, bits    -- registers
    sequence fList, list            -- drive lists
    integer firstHD                 -- where to start looking for HD

    inReg = repeat( 0, 10 )         -- initialize register list

    -- get floppy list
    fList = floppies()

    -- start location for hard drives is past floppies
    firstHD = length( fList ) + 1

    -- if only one floppy, hard drive is c:
    if length( fList ) = 1 then
        firstHD = firstHD + 1
    end if

    -- clear list
    list = {}

    -- check possible hard drives
    for bl = firstHD to 26 do

        -- dos call
        inReg[REG_AX] = #4409                   -- function 44, sub 09
        inReg[REG_BX] = bl                      -- drive letter
        outReg = dos_interrupt( #21, inReg )    -- bios call

        -- check carry flag
        bits = int_to_bits( outReg[REG_FLAGS], 16 )
        if bits[1] = 0 then
            -- add drive
            list = append( list, "<-" & { 'A' - 1 + bl } & "->" )
        end if

    end for

    return list
end function
----------------------------------------
global function ListSelect(sequence RC,sequence s,integer many)
--Quark: present scrolling list of s from which item(s) may be selected.
-- If many is 0 then 1 item may be selectd, else many.
-- Returns sequence containing selected item(s) or {}.
-- RC is: {r1,c1,r2,c2} defining a rectangle for the list
integer slotTop,slotBot
integer listTop,listBot
integer curTop,curBot
integer rowOff,colOff
integer cursLoc,select
integer count,key,state,c,cnt
sequence temp
temp={}
listTop=1
slotTop=1
curTop=1
listBot=length(s)
slotBot=RC[3]-RC[1]+1
rowOff=RC[1]
colOff=RC[2]
c=' '
for i=1 to slotBot do
   position(rowOff+i-1,colOff)
   puts(1,repeat(' ',RC[4]-RC[2]+1))
end for
if listBot<slotBot then
   slotBot=listBot
end if
curBot=slotBot
cursLoc=1
for i=1 to listBot do
   s[i]=Pad(s[i],RC[4]-RC[2]+1,RIGHT)
end for
while 1 do
   key=1
   state=GO
   while key do
      count=1
      for i=curTop to curBot do
         if count=cursLoc then
            bk_color(curHue[4])
         else
            bk_color(curHue[2])
         end if
         PlaceAt({rowOff+count-1,colOff},s[i])
         count+=1
         if count>slotBot then
            exit
         end if
      end for
      key=((wait_key())-('a'-'A')*(key>='a' and key<='z'))
      if key=ESC then
         key=0
         state=CANCEL
         exit
      elsif key=UP then
         if cursLoc>slotTop then
            cursLoc=cursLoc-(1*(cursLoc!=listTop))
         else
            if curTop>listTop then
               curTop-=1
               curBot-=1
            end if
         end if
      elsif key=DOWN then
         if cursLoc<slotBot then
            cursLoc=cursLoc+(1*(cursLoc!=listBot))
         else
            if curBot<listBot then
               curTop+=1
               curBot+=1
            end if
         end if
      elsif key=SPACE then
         if many then
            select=cursLoc+curTop-1
            c=s[select][length(s[select])]
            if equal(c,'<') then
              s[select][length(s[select])]=' '
            else
              s[select][length(s[select])]='<'
            end if
         end if
      elsif key=PGUP then
         count=0
         while count<slotBot do
            count+=1
            --cursLoc=cursLoc-1*(cursLoc>slotTop)
            if curTop>listTop then
               curTop-=1
               curBot-=1
            end if
         end while
      elsif key=HOME then
         curTop=slotTop
         curBot=slotBot
         cursLoc=slotTop
      elsif key=END then
         curBot=listBot
         curTop=listBot-slotBot+1
         cursLoc=slotBot
      elsif key=PGDOWN then
         count=0
         while count<slotBot do
            count+=1
            --cursLoc=cursLoc+(1*cursLoc<slotBot)
            if curBot<listBot then
               curTop+=1
               curBot+=1
            end if
         end while
      elsif key=ENTER then
        state=ENTER
        select=cursLoc+curTop-1
        if equal(many,0) then
           s[select][length(s[select])]='<'
           for i=1 to length(s) do
            if not equal(i,select) then
              s[i][length(s[i])]=' '
            end if
           end for
        else
           cnt=0
           for i=1 to length(s) do
            if  equal(s[i][length(s[i])],'<') then
              cnt+=1             
            end if
           end for
          if equal(cnt,0) then
            s[select][length(s[select])]='<'
          end if
        end if
        exit
      end if
   end while
   if state=CANCEL then
      return {"Cancelled"}
   elsif state=ENTER then
      exit
   end if
end while
if many then
   temp={}
   for i=1 to length(s) do
      if s[i][length(s[i])]='<' then
         for j=length(s[i])-1 to 1 by -1 do
            if not equal(s[i][j],32) then
               s[i]=s[i][1..j]
               temp=append(temp,s[i])
               exit
            end if
         end for
     end if
   end for
   return temp
else
   for i=1 to length(s) do
      if equal(s[i][length(s[i])],'<') then
         for j=length(s[i])-1 to 1 by -1 do
            if not equal(s[i][j],32) then
               return {s[i][1..j]}
            end if
         end for
      end if
   end for
end if
end function
----------------------------------------
function EffectivePath(sequence p,sequence choice)
   sequence t
   t={"Normal",{},{}}
   if equal(choice[1],"Cancelled") then
      return {"Cancelled",{},{}}
   end if
   for i=1 to length(choice) do
      if equal(choice[i][1],'<') then
         choice={choice[i]}
         exit
      end if
   end for
   if length(choice)=1 and equal(choice[1][1],'<') then
      --must be drive or directory
      if equal(choice[1],"<..>") then --go up hierarchy
         if length(p[2])>3 then
            for i=length(p[2])-2 to 1 by -1 do
               if equal(p[2][i],'\\') then
                  return {"Normal",p[2][1..i],{}}
               end if
            end for
         else
            return {"Normal",p[2],{}}
         end if
      elsif equal(choice[1][1..2],"<-") then --must be drive
         return {"NewDrive",choice[1][3]&":\\",{}}
      elsif equal(choice[1][1],'<') then --must be directory
         return {"Normal",p[2]&choice[1][2..length(choice[1])-1]&'\\',{}}
      end if
   else --must be files
      return {"HasFiles",p[2],choice}
   end if
end function
----------------------------------------
function QDir(sequence path)
object d,t
t=floppies()&hard_drives()
d=dir(path)
if equal(d,-1) then
   return -1
end if
for i=1to length(d) do
   if equal(d[i][D_ATTRIBUTES],"d") then
      d[i][D_NAME]='<'&d[i][D_NAME]&'>'
   end if
   if not equal(d[i][D_NAME],"<.>") then
      t=append(t,d[i][D_NAME])
   end if
end for
return sort(t)
end function
----------------------------------------
global function fs()
object fileData,current
sequence fileSpec,help
help={
      "Use the UP and DOWN arrows, PAGEUP, PAGEDOWN,",
      "HOME, and END keys to move around.  Select a",
      "single drive or a single directory with the",
      "ENTER key.  To go back up the hierarchy of the",
      "directory, press ENTER on the <..> pattern.",
      "",
      "To cancel, press <ESC>.",
      "",
      "To select a single file, press ENTER on it.",
      "",
      "To select multiple files, press the spacebar",
      "on each file, then press ENTER to finish.",
      "",
      "Be careful to only select a drive with a disk,",
      "otherwise your program will crash!"
     }
fileSpec="*.*"
--text_color(curHue[1])
--bk_color(curHue[2])
clear_screen()
rc={1,1,3,MAXCOL}
Box(rc)
rc={4,1,23,50}
QBox(rc,"Instructions for File Selection")
for i=1 to length(help) do
   PlaceAt({i+rc[1]+3,rc[2]+2},help[i])
end for
rc={4,72,23,MAXCOL}
Box(rc)
CenterAt(2,"File Select Screen")
rc={24,1,24,MAXCOL}
PlaceAt(rc,PART[1][2])
rc={4,51,23,71}
QBox(rc,"Drives-Dirs-Files")
fileData={"Normal","c:\\",{}}
current={}
rc={rc[1]+3,rc[2]+1,rc[3]-1,rc[4]-1}
while 1 do
   current=QDir(fileData[2]&fileSpec)
   if equal(current,-1) then
      CenterAt(MAXROW,"Read failed with path "&fileData[2])
      return {"Cancelled",{},{}}
   end if
   current=ListSelect(rc,current,1)
   --current=ListSelect({7,29,21,51},current,1)
   fileData=EffectivePath(fileData,current)
   if equal(fileData[1],"HasFiles") or equal(fileData[1],"Cancelled") then
      return fileData
   end if
end while
end function
----------------------------------------



